// generated from rosidl_generator_cpp/resource/msg__struct.hpp.em
// generated code does not contain a copyright notice

#ifndef ML_CLASSIFIERS__MSG__CLASS_DATA_POINT__STRUCT_HPP_
#define ML_CLASSIFIERS__MSG__CLASS_DATA_POINT__STRUCT_HPP_

// Protect against ERROR being predefined on Windows, in case somebody defines a
// constant by that name.
#if defined(_WIN32) && defined(ERROR)
  #undef ERROR
#endif

#include <rosidl_generator_cpp/bounded_vector.hpp>
#include <rosidl_generator_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

// include message dependencies

#ifndef _WIN32
# define DEPRECATED_ml_classifiers_msg_ClassDataPoint __attribute__((deprecated))
#else
# define DEPRECATED_ml_classifiers_msg_ClassDataPoint __declspec(deprecated)
#endif

namespace ml_classifiers
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct ClassDataPoint_
{
  using Type = ClassDataPoint_<ContainerAllocator>;

  explicit ClassDataPoint_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->target_class = "";
    }
  }

  explicit ClassDataPoint_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : target_class(_alloc)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->target_class = "";
    }
  }

  // field types and members
  using _target_class_type =
    std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>;
  _target_class_type target_class;
  using _point_type =
    std::vector<double, typename ContainerAllocator::template rebind<double>::other>;
  _point_type point;

  // setters for named parameter idiom
  Type * set__target_class(
    const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> & _arg)
  {
    this->target_class = _arg;
    return this;
  }
  Type * set__point(
    const std::vector<double, typename ContainerAllocator::template rebind<double>::other> & _arg)
  {
    this->point = _arg;
    return this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    ml_classifiers::msg::ClassDataPoint_<ContainerAllocator> *;
  using ConstRawPtr =
    const ml_classifiers::msg::ClassDataPoint_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<ml_classifiers::msg::ClassDataPoint_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<ml_classifiers::msg::ClassDataPoint_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      ml_classifiers::msg::ClassDataPoint_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<ml_classifiers::msg::ClassDataPoint_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      ml_classifiers::msg::ClassDataPoint_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<ml_classifiers::msg::ClassDataPoint_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<ml_classifiers::msg::ClassDataPoint_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<ml_classifiers::msg::ClassDataPoint_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED_ml_classifiers_msg_ClassDataPoint
    std::shared_ptr<ml_classifiers::msg::ClassDataPoint_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED_ml_classifiers_msg_ClassDataPoint
    std::shared_ptr<ml_classifiers::msg::ClassDataPoint_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ClassDataPoint_ & other) const
  {
    if (this->target_class != other.target_class) {
      return false;
    }
    if (this->point != other.point) {
      return false;
    }
    return true;
  }
  bool operator!=(const ClassDataPoint_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ClassDataPoint_

// alias to use template instance with default allocator
using ClassDataPoint =
  ml_classifiers::msg::ClassDataPoint_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace ml_classifiers

#endif  // ML_CLASSIFIERS__MSG__CLASS_DATA_POINT__STRUCT_HPP_
