// generated from rosidl_generator_cpp/resource/msg__struct.hpp.em
// generated code does not contain a copyright notice

#ifndef ML_CLASSIFIERS__SRV__ADD_CLASS_DATA__RESPONSE__STRUCT_HPP_
#define ML_CLASSIFIERS__SRV__ADD_CLASS_DATA__RESPONSE__STRUCT_HPP_

// Protect against ERROR being predefined on Windows, in case somebody defines a
// constant by that name.
#if defined(_WIN32) && defined(ERROR)
  #undef ERROR
#endif

#include <rosidl_generator_cpp/bounded_vector.hpp>
#include <rosidl_generator_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

// include message dependencies

#ifndef _WIN32
# define DEPRECATED_ml_classifiers_srv_AddClassData_Response __attribute__((deprecated))
#else
# define DEPRECATED_ml_classifiers_srv_AddClassData_Response __declspec(deprecated)
#endif

namespace ml_classifiers
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct AddClassData_Response_
{
  using Type = AddClassData_Response_<ContainerAllocator>;

  explicit AddClassData_Response_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->success = false;
    }
  }

  explicit AddClassData_Response_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->success = false;
    }
  }

  // field types and members
  using _success_type =
    bool;
  _success_type success;

  // setters for named parameter idiom
  Type * set__success(
    const bool & _arg)
  {
    this->success = _arg;
    return this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    ml_classifiers::srv::AddClassData_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const ml_classifiers::srv::AddClassData_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<ml_classifiers::srv::AddClassData_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<ml_classifiers::srv::AddClassData_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      ml_classifiers::srv::AddClassData_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<ml_classifiers::srv::AddClassData_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      ml_classifiers::srv::AddClassData_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<ml_classifiers::srv::AddClassData_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<ml_classifiers::srv::AddClassData_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<ml_classifiers::srv::AddClassData_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED_ml_classifiers_srv_AddClassData_Response
    std::shared_ptr<ml_classifiers::srv::AddClassData_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED_ml_classifiers_srv_AddClassData_Response
    std::shared_ptr<ml_classifiers::srv::AddClassData_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const AddClassData_Response_ & other) const
  {
    if (this->success != other.success) {
      return false;
    }
    return true;
  }
  bool operator!=(const AddClassData_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct AddClassData_Response_

// alias to use template instance with default allocator
using AddClassData_Response =
  ml_classifiers::srv::AddClassData_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace ml_classifiers

#endif  // ML_CLASSIFIERS__SRV__ADD_CLASS_DATA__RESPONSE__STRUCT_HPP_
