#ifndef _H_61B4D6CBBA251EEF634CB3FB15D48B22_AddClassData_Request_DCPS_H_
#define _H_61B4D6CBBA251EEF634CB3FB15D48B22_AddClassData_Request_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "AddClassData_Request_.h"


namespace ml_classifiers
{
    namespace srv
    {
        namespace dds_
        {
            class AddClassData_Request_TypeSupportInterface;

            typedef AddClassData_Request_TypeSupportInterface * AddClassData_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < AddClassData_Request_TypeSupportInterface> AddClassData_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < AddClassData_Request_TypeSupportInterface> AddClassData_Request_TypeSupportInterface_out;


            class AddClassData_Request_DataWriter;

            typedef AddClassData_Request_DataWriter * AddClassData_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < AddClassData_Request_DataWriter> AddClassData_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < AddClassData_Request_DataWriter> AddClassData_Request_DataWriter_out;


            class AddClassData_Request_DataReader;

            typedef AddClassData_Request_DataReader * AddClassData_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < AddClassData_Request_DataReader> AddClassData_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < AddClassData_Request_DataReader> AddClassData_Request_DataReader_out;


            class AddClassData_Request_DataReaderView;

            typedef AddClassData_Request_DataReaderView * AddClassData_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < AddClassData_Request_DataReaderView> AddClassData_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < AddClassData_Request_DataReaderView> AddClassData_Request_DataReaderView_out;

            struct AddClassData_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < AddClassData_Request_, struct AddClassData_Request_Seq_uniq_> AddClassData_Request_Seq;
            typedef DDS_DCPSSequence_var < AddClassData_Request_Seq> AddClassData_Request_Seq_var;
            typedef DDS_DCPSSequence_out < AddClassData_Request_Seq> AddClassData_Request_Seq_out;

            class  AddClassData_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef AddClassData_Request_TypeSupportInterface_ptr _ptr_type;
                typedef AddClassData_Request_TypeSupportInterface_var _var_type;

                static AddClassData_Request_TypeSupportInterface_ptr _duplicate (AddClassData_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AddClassData_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static AddClassData_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AddClassData_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                AddClassData_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                AddClassData_Request_TypeSupportInterface () {};
                ~AddClassData_Request_TypeSupportInterface () {};
            private:
                AddClassData_Request_TypeSupportInterface (const AddClassData_Request_TypeSupportInterface &);
                AddClassData_Request_TypeSupportInterface & operator = (const AddClassData_Request_TypeSupportInterface &);
            };

            class  AddClassData_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef AddClassData_Request_DataWriter_ptr _ptr_type;
                typedef AddClassData_Request_DataWriter_var _var_type;

                static AddClassData_Request_DataWriter_ptr _duplicate (AddClassData_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AddClassData_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static AddClassData_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AddClassData_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                AddClassData_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const AddClassData_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const AddClassData_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const AddClassData_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const AddClassData_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const AddClassData_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const AddClassData_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const AddClassData_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const AddClassData_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const AddClassData_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const AddClassData_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (AddClassData_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AddClassData_Request_& instance_data) = 0;

            protected:
                AddClassData_Request_DataWriter () {};
                ~AddClassData_Request_DataWriter () {};
            private:
                AddClassData_Request_DataWriter (const AddClassData_Request_DataWriter &);
                AddClassData_Request_DataWriter & operator = (const AddClassData_Request_DataWriter &);
            };

            class  AddClassData_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef AddClassData_Request_DataReader_ptr _ptr_type;
                typedef AddClassData_Request_DataReader_var _var_type;

                static AddClassData_Request_DataReader_ptr _duplicate (AddClassData_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AddClassData_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static AddClassData_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AddClassData_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                AddClassData_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (AddClassData_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (AddClassData_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (AddClassData_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (AddClassData_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (AddClassData_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (AddClassData_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (AddClassData_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (AddClassData_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (AddClassData_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (AddClassData_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (AddClassData_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (AddClassData_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (AddClassData_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (AddClassData_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AddClassData_Request_& instance) = 0;

            protected:
                AddClassData_Request_DataReader () {};
                ~AddClassData_Request_DataReader () {};
            private:
                AddClassData_Request_DataReader (const AddClassData_Request_DataReader &);
                AddClassData_Request_DataReader & operator = (const AddClassData_Request_DataReader &);
            };

            class  AddClassData_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef AddClassData_Request_DataReaderView_ptr _ptr_type;
                typedef AddClassData_Request_DataReaderView_var _var_type;

                static AddClassData_Request_DataReaderView_ptr _duplicate (AddClassData_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AddClassData_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static AddClassData_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AddClassData_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                AddClassData_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (AddClassData_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (AddClassData_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (AddClassData_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (AddClassData_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (AddClassData_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (AddClassData_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (AddClassData_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (AddClassData_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (AddClassData_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (AddClassData_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (AddClassData_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (AddClassData_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (AddClassData_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (AddClassData_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AddClassData_Request_& instance) = 0;

            protected:
                AddClassData_Request_DataReaderView () {};
                ~AddClassData_Request_DataReaderView () {};
            private:
                AddClassData_Request_DataReaderView (const AddClassData_Request_DataReaderView &);
                AddClassData_Request_DataReaderView & operator = (const AddClassData_Request_DataReaderView &);
            };
        }

    }

}

#endif
