#ifndef _H_B24A9B0C1E8B9CA709C475C4AC5E10DC_Sample_AddClassData_Request_DCPS_H_
#define _H_B24A9B0C1E8B9CA709C475C4AC5E10DC_Sample_AddClassData_Request_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "Sample_AddClassData_Request_.h"


namespace ml_classifiers
{
    namespace srv
    {
        namespace dds_
        {
            class Sample_AddClassData_Request_TypeSupportInterface;

            typedef Sample_AddClassData_Request_TypeSupportInterface * Sample_AddClassData_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_AddClassData_Request_TypeSupportInterface> Sample_AddClassData_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_AddClassData_Request_TypeSupportInterface> Sample_AddClassData_Request_TypeSupportInterface_out;


            class Sample_AddClassData_Request_DataWriter;

            typedef Sample_AddClassData_Request_DataWriter * Sample_AddClassData_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_AddClassData_Request_DataWriter> Sample_AddClassData_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_AddClassData_Request_DataWriter> Sample_AddClassData_Request_DataWriter_out;


            class Sample_AddClassData_Request_DataReader;

            typedef Sample_AddClassData_Request_DataReader * Sample_AddClassData_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_AddClassData_Request_DataReader> Sample_AddClassData_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_AddClassData_Request_DataReader> Sample_AddClassData_Request_DataReader_out;


            class Sample_AddClassData_Request_DataReaderView;

            typedef Sample_AddClassData_Request_DataReaderView * Sample_AddClassData_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_AddClassData_Request_DataReaderView> Sample_AddClassData_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_AddClassData_Request_DataReaderView> Sample_AddClassData_Request_DataReaderView_out;

            struct Sample_AddClassData_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_AddClassData_Request_, struct Sample_AddClassData_Request_Seq_uniq_> Sample_AddClassData_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_AddClassData_Request_Seq> Sample_AddClassData_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_AddClassData_Request_Seq> Sample_AddClassData_Request_Seq_out;

            class  Sample_AddClassData_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_AddClassData_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_AddClassData_Request_TypeSupportInterface_var _var_type;

                static Sample_AddClassData_Request_TypeSupportInterface_ptr _duplicate (Sample_AddClassData_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_AddClassData_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_AddClassData_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_AddClassData_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_AddClassData_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_AddClassData_Request_TypeSupportInterface () {};
                ~Sample_AddClassData_Request_TypeSupportInterface () {};
            private:
                Sample_AddClassData_Request_TypeSupportInterface (const Sample_AddClassData_Request_TypeSupportInterface &);
                Sample_AddClassData_Request_TypeSupportInterface & operator = (const Sample_AddClassData_Request_TypeSupportInterface &);
            };

            class  Sample_AddClassData_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_AddClassData_Request_DataWriter_ptr _ptr_type;
                typedef Sample_AddClassData_Request_DataWriter_var _var_type;

                static Sample_AddClassData_Request_DataWriter_ptr _duplicate (Sample_AddClassData_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_AddClassData_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_AddClassData_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_AddClassData_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_AddClassData_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_AddClassData_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_AddClassData_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_AddClassData_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_AddClassData_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_AddClassData_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_AddClassData_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_AddClassData_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_AddClassData_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_AddClassData_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_AddClassData_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_AddClassData_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_AddClassData_Request_& instance_data) = 0;

            protected:
                Sample_AddClassData_Request_DataWriter () {};
                ~Sample_AddClassData_Request_DataWriter () {};
            private:
                Sample_AddClassData_Request_DataWriter (const Sample_AddClassData_Request_DataWriter &);
                Sample_AddClassData_Request_DataWriter & operator = (const Sample_AddClassData_Request_DataWriter &);
            };

            class  Sample_AddClassData_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_AddClassData_Request_DataReader_ptr _ptr_type;
                typedef Sample_AddClassData_Request_DataReader_var _var_type;

                static Sample_AddClassData_Request_DataReader_ptr _duplicate (Sample_AddClassData_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_AddClassData_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_AddClassData_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_AddClassData_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_AddClassData_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_AddClassData_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_AddClassData_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_AddClassData_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_AddClassData_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_AddClassData_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_AddClassData_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_AddClassData_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_AddClassData_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_AddClassData_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_AddClassData_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_AddClassData_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_AddClassData_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_AddClassData_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_AddClassData_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_AddClassData_Request_& instance) = 0;

            protected:
                Sample_AddClassData_Request_DataReader () {};
                ~Sample_AddClassData_Request_DataReader () {};
            private:
                Sample_AddClassData_Request_DataReader (const Sample_AddClassData_Request_DataReader &);
                Sample_AddClassData_Request_DataReader & operator = (const Sample_AddClassData_Request_DataReader &);
            };

            class  Sample_AddClassData_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_AddClassData_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_AddClassData_Request_DataReaderView_var _var_type;

                static Sample_AddClassData_Request_DataReaderView_ptr _duplicate (Sample_AddClassData_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_AddClassData_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_AddClassData_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_AddClassData_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_AddClassData_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_AddClassData_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_AddClassData_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_AddClassData_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_AddClassData_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_AddClassData_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_AddClassData_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_AddClassData_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_AddClassData_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_AddClassData_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_AddClassData_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_AddClassData_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_AddClassData_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_AddClassData_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_AddClassData_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_AddClassData_Request_& instance) = 0;

            protected:
                Sample_AddClassData_Request_DataReaderView () {};
                ~Sample_AddClassData_Request_DataReaderView () {};
            private:
                Sample_AddClassData_Request_DataReaderView (const Sample_AddClassData_Request_DataReaderView &);
                Sample_AddClassData_Request_DataReaderView & operator = (const Sample_AddClassData_Request_DataReaderView &);
            };
        }

    }

}

#endif
