#ifndef _H_774EE028F456890614CDA9F3059E32BC_TrainClassifier_Response_DCPS_H_
#define _H_774EE028F456890614CDA9F3059E32BC_TrainClassifier_Response_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "TrainClassifier_Response_.h"


namespace ml_classifiers
{
    namespace srv
    {
        namespace dds_
        {
            class TrainClassifier_Response_TypeSupportInterface;

            typedef TrainClassifier_Response_TypeSupportInterface * TrainClassifier_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < TrainClassifier_Response_TypeSupportInterface> TrainClassifier_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < TrainClassifier_Response_TypeSupportInterface> TrainClassifier_Response_TypeSupportInterface_out;


            class TrainClassifier_Response_DataWriter;

            typedef TrainClassifier_Response_DataWriter * TrainClassifier_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < TrainClassifier_Response_DataWriter> TrainClassifier_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < TrainClassifier_Response_DataWriter> TrainClassifier_Response_DataWriter_out;


            class TrainClassifier_Response_DataReader;

            typedef TrainClassifier_Response_DataReader * TrainClassifier_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < TrainClassifier_Response_DataReader> TrainClassifier_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < TrainClassifier_Response_DataReader> TrainClassifier_Response_DataReader_out;


            class TrainClassifier_Response_DataReaderView;

            typedef TrainClassifier_Response_DataReaderView * TrainClassifier_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < TrainClassifier_Response_DataReaderView> TrainClassifier_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < TrainClassifier_Response_DataReaderView> TrainClassifier_Response_DataReaderView_out;

            struct TrainClassifier_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < TrainClassifier_Response_, struct TrainClassifier_Response_Seq_uniq_> TrainClassifier_Response_Seq;
            typedef DDS_DCPSSequence_var < TrainClassifier_Response_Seq> TrainClassifier_Response_Seq_var;
            typedef DDS_DCPSSequence_out < TrainClassifier_Response_Seq> TrainClassifier_Response_Seq_out;

            class  TrainClassifier_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef TrainClassifier_Response_TypeSupportInterface_ptr _ptr_type;
                typedef TrainClassifier_Response_TypeSupportInterface_var _var_type;

                static TrainClassifier_Response_TypeSupportInterface_ptr _duplicate (TrainClassifier_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TrainClassifier_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static TrainClassifier_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TrainClassifier_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                TrainClassifier_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                TrainClassifier_Response_TypeSupportInterface () {};
                ~TrainClassifier_Response_TypeSupportInterface () {};
            private:
                TrainClassifier_Response_TypeSupportInterface (const TrainClassifier_Response_TypeSupportInterface &);
                TrainClassifier_Response_TypeSupportInterface & operator = (const TrainClassifier_Response_TypeSupportInterface &);
            };

            class  TrainClassifier_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef TrainClassifier_Response_DataWriter_ptr _ptr_type;
                typedef TrainClassifier_Response_DataWriter_var _var_type;

                static TrainClassifier_Response_DataWriter_ptr _duplicate (TrainClassifier_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TrainClassifier_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static TrainClassifier_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TrainClassifier_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                TrainClassifier_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const TrainClassifier_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const TrainClassifier_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const TrainClassifier_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const TrainClassifier_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const TrainClassifier_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const TrainClassifier_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const TrainClassifier_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const TrainClassifier_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const TrainClassifier_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const TrainClassifier_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (TrainClassifier_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const TrainClassifier_Response_& instance_data) = 0;

            protected:
                TrainClassifier_Response_DataWriter () {};
                ~TrainClassifier_Response_DataWriter () {};
            private:
                TrainClassifier_Response_DataWriter (const TrainClassifier_Response_DataWriter &);
                TrainClassifier_Response_DataWriter & operator = (const TrainClassifier_Response_DataWriter &);
            };

            class  TrainClassifier_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef TrainClassifier_Response_DataReader_ptr _ptr_type;
                typedef TrainClassifier_Response_DataReader_var _var_type;

                static TrainClassifier_Response_DataReader_ptr _duplicate (TrainClassifier_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TrainClassifier_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static TrainClassifier_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TrainClassifier_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                TrainClassifier_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (TrainClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (TrainClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (TrainClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (TrainClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (TrainClassifier_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (TrainClassifier_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (TrainClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (TrainClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (TrainClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (TrainClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (TrainClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (TrainClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (TrainClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (TrainClassifier_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const TrainClassifier_Response_& instance) = 0;

            protected:
                TrainClassifier_Response_DataReader () {};
                ~TrainClassifier_Response_DataReader () {};
            private:
                TrainClassifier_Response_DataReader (const TrainClassifier_Response_DataReader &);
                TrainClassifier_Response_DataReader & operator = (const TrainClassifier_Response_DataReader &);
            };

            class  TrainClassifier_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef TrainClassifier_Response_DataReaderView_ptr _ptr_type;
                typedef TrainClassifier_Response_DataReaderView_var _var_type;

                static TrainClassifier_Response_DataReaderView_ptr _duplicate (TrainClassifier_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TrainClassifier_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static TrainClassifier_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TrainClassifier_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                TrainClassifier_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (TrainClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (TrainClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (TrainClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (TrainClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (TrainClassifier_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (TrainClassifier_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (TrainClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (TrainClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (TrainClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (TrainClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (TrainClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (TrainClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (TrainClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (TrainClassifier_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const TrainClassifier_Response_& instance) = 0;

            protected:
                TrainClassifier_Response_DataReaderView () {};
                ~TrainClassifier_Response_DataReaderView () {};
            private:
                TrainClassifier_Response_DataReaderView (const TrainClassifier_Response_DataReaderView &);
                TrainClassifier_Response_DataReaderView & operator = (const TrainClassifier_Response_DataReaderView &);
            };
        }

    }

}

#endif
