// generated from rosidl_generator_c/resource/msg__functions.h.em
// generated code does not contain a copyright notice

#ifndef ML_CLASSIFIERS__SRV__TRAIN_CLASSIFIER__REQUEST__FUNCTIONS_H_
#define ML_CLASSIFIERS__SRV__TRAIN_CLASSIFIER__REQUEST__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_generator_c/visibility_control.h"
#include "ml_classifiers/msg/rosidl_generator_c__visibility_control.h"

#include "ml_classifiers/srv/train_classifier__request__struct.h"

/// Initialize ml_classifiers/TrainClassifier_Request message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(ml_classifiers__srv__TrainClassifier_Request)) before
 * or use ml_classifiers__srv__TrainClassifier_Request__create() to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_ml_classifiers
bool
ml_classifiers__srv__TrainClassifier_Request__init(ml_classifiers__srv__TrainClassifier_Request * msg);

/// Finalize ml_classifiers/TrainClassifier_Request message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_ml_classifiers
void
ml_classifiers__srv__TrainClassifier_Request__fini(ml_classifiers__srv__TrainClassifier_Request * msg);

/// Create ml_classifiers/TrainClassifier_Request message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls ml_classifiers__srv__TrainClassifier_Request__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_ml_classifiers
ml_classifiers__srv__TrainClassifier_Request *
ml_classifiers__srv__TrainClassifier_Request__create();

/// Destroy ml_classifiers/TrainClassifier_Request message.
/**
 * It calls ml_classifiers__srv__TrainClassifier_Request__fini() and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_ml_classifiers
void
ml_classifiers__srv__TrainClassifier_Request__destroy(ml_classifiers__srv__TrainClassifier_Request * msg);


/// Initialize array of ml_classifiers/TrainClassifier_Request messages.
/**
 * It allocates the memory for the number of elements and
 * calls ml_classifiers__srv__TrainClassifier_Request__init() for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_ml_classifiers
bool
ml_classifiers__srv__TrainClassifier_Request__Sequence__init(ml_classifiers__srv__TrainClassifier_Request__Sequence * array, size_t size);

/// Finalize array of ml_classifiers/TrainClassifier_Request messages.
/**
 * It calls ml_classifiers__srv__TrainClassifier_Request__fini() for each element of the array and
 * frees the memory for the number of elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_ml_classifiers
void
ml_classifiers__srv__TrainClassifier_Request__Sequence__fini(ml_classifiers__srv__TrainClassifier_Request__Sequence * array);

/// Create array of ml_classifiers/TrainClassifier_Request messages.
/**
 * It allocates the memory for the array and
 * calls ml_classifiers__srv__TrainClassifier_Request__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_ml_classifiers
ml_classifiers__srv__TrainClassifier_Request__Sequence *
ml_classifiers__srv__TrainClassifier_Request__Sequence__create(size_t size);

/// Destroy array of ml_classifiers/TrainClassifier_Request messages.
/**
 * It calls ml_classifiers__srv__TrainClassifier_Request__Sequence__fini() on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_ml_classifiers
void
ml_classifiers__srv__TrainClassifier_Request__Sequence__destroy(ml_classifiers__srv__TrainClassifier_Request__Sequence * array);

#ifdef __cplusplus
}
#endif

#endif  // ML_CLASSIFIERS__SRV__TRAIN_CLASSIFIER__REQUEST__FUNCTIONS_H_
