// generated from rosidl_generator_cpp/resource/msg__struct.hpp.em
// generated code does not contain a copyright notice

#ifndef ML_CLASSIFIERS__SRV__CLASSIFY_DATA__REQUEST__STRUCT_HPP_
#define ML_CLASSIFIERS__SRV__CLASSIFY_DATA__REQUEST__STRUCT_HPP_

// Protect against ERROR being predefined on Windows, in case somebody defines a
// constant by that name.
#if defined(_WIN32) && defined(ERROR)
  #undef ERROR
#endif

#include <rosidl_generator_cpp/bounded_vector.hpp>
#include <rosidl_generator_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

// include message dependencies
#include "ml_classifiers/msg/class_data_point.hpp"  // data

#ifndef _WIN32
# define DEPRECATED_ml_classifiers_srv_ClassifyData_Request __attribute__((deprecated))
#else
# define DEPRECATED_ml_classifiers_srv_ClassifyData_Request __declspec(deprecated)
#endif

namespace ml_classifiers
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct ClassifyData_Request_
{
  using Type = ClassifyData_Request_<ContainerAllocator>;

  explicit ClassifyData_Request_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->identifier = "";
    }
  }

  explicit ClassifyData_Request_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : identifier(_alloc)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->identifier = "";
    }
  }

  // field types and members
  using _identifier_type =
    std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>;
  _identifier_type identifier;
  using _data_type =
    std::vector<ml_classifiers::msg::ClassDataPoint_<ContainerAllocator>, typename ContainerAllocator::template rebind<ml_classifiers::msg::ClassDataPoint_<ContainerAllocator>>::other>;
  _data_type data;

  // setters for named parameter idiom
  Type * set__identifier(
    const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> & _arg)
  {
    this->identifier = _arg;
    return this;
  }
  Type * set__data(
    const std::vector<ml_classifiers::msg::ClassDataPoint_<ContainerAllocator>, typename ContainerAllocator::template rebind<ml_classifiers::msg::ClassDataPoint_<ContainerAllocator>>::other> & _arg)
  {
    this->data = _arg;
    return this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    ml_classifiers::srv::ClassifyData_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const ml_classifiers::srv::ClassifyData_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<ml_classifiers::srv::ClassifyData_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<ml_classifiers::srv::ClassifyData_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      ml_classifiers::srv::ClassifyData_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<ml_classifiers::srv::ClassifyData_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      ml_classifiers::srv::ClassifyData_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<ml_classifiers::srv::ClassifyData_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<ml_classifiers::srv::ClassifyData_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<ml_classifiers::srv::ClassifyData_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED_ml_classifiers_srv_ClassifyData_Request
    std::shared_ptr<ml_classifiers::srv::ClassifyData_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED_ml_classifiers_srv_ClassifyData_Request
    std::shared_ptr<ml_classifiers::srv::ClassifyData_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ClassifyData_Request_ & other) const
  {
    if (this->identifier != other.identifier) {
      return false;
    }
    if (this->data != other.data) {
      return false;
    }
    return true;
  }
  bool operator!=(const ClassifyData_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ClassifyData_Request_

// alias to use template instance with default allocator
using ClassifyData_Request =
  ml_classifiers::srv::ClassifyData_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace ml_classifiers

#endif  // ML_CLASSIFIERS__SRV__CLASSIFY_DATA__REQUEST__STRUCT_HPP_
