#ifndef _H_B13B7A2F691DC3A5F57D6233EB166E64_CreateClassifier_Request_DCPS_H_
#define _H_B13B7A2F691DC3A5F57D6233EB166E64_CreateClassifier_Request_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "CreateClassifier_Request_.h"


namespace ml_classifiers
{
    namespace srv
    {
        namespace dds_
        {
            class CreateClassifier_Request_TypeSupportInterface;

            typedef CreateClassifier_Request_TypeSupportInterface * CreateClassifier_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < CreateClassifier_Request_TypeSupportInterface> CreateClassifier_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < CreateClassifier_Request_TypeSupportInterface> CreateClassifier_Request_TypeSupportInterface_out;


            class CreateClassifier_Request_DataWriter;

            typedef CreateClassifier_Request_DataWriter * CreateClassifier_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < CreateClassifier_Request_DataWriter> CreateClassifier_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < CreateClassifier_Request_DataWriter> CreateClassifier_Request_DataWriter_out;


            class CreateClassifier_Request_DataReader;

            typedef CreateClassifier_Request_DataReader * CreateClassifier_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < CreateClassifier_Request_DataReader> CreateClassifier_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < CreateClassifier_Request_DataReader> CreateClassifier_Request_DataReader_out;


            class CreateClassifier_Request_DataReaderView;

            typedef CreateClassifier_Request_DataReaderView * CreateClassifier_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < CreateClassifier_Request_DataReaderView> CreateClassifier_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < CreateClassifier_Request_DataReaderView> CreateClassifier_Request_DataReaderView_out;

            struct CreateClassifier_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < CreateClassifier_Request_, struct CreateClassifier_Request_Seq_uniq_> CreateClassifier_Request_Seq;
            typedef DDS_DCPSSequence_var < CreateClassifier_Request_Seq> CreateClassifier_Request_Seq_var;
            typedef DDS_DCPSSequence_out < CreateClassifier_Request_Seq> CreateClassifier_Request_Seq_out;

            class  CreateClassifier_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef CreateClassifier_Request_TypeSupportInterface_ptr _ptr_type;
                typedef CreateClassifier_Request_TypeSupportInterface_var _var_type;

                static CreateClassifier_Request_TypeSupportInterface_ptr _duplicate (CreateClassifier_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CreateClassifier_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static CreateClassifier_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CreateClassifier_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                CreateClassifier_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                CreateClassifier_Request_TypeSupportInterface () {};
                ~CreateClassifier_Request_TypeSupportInterface () {};
            private:
                CreateClassifier_Request_TypeSupportInterface (const CreateClassifier_Request_TypeSupportInterface &);
                CreateClassifier_Request_TypeSupportInterface & operator = (const CreateClassifier_Request_TypeSupportInterface &);
            };

            class  CreateClassifier_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef CreateClassifier_Request_DataWriter_ptr _ptr_type;
                typedef CreateClassifier_Request_DataWriter_var _var_type;

                static CreateClassifier_Request_DataWriter_ptr _duplicate (CreateClassifier_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CreateClassifier_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static CreateClassifier_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CreateClassifier_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                CreateClassifier_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const CreateClassifier_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const CreateClassifier_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const CreateClassifier_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const CreateClassifier_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const CreateClassifier_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const CreateClassifier_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const CreateClassifier_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const CreateClassifier_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const CreateClassifier_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const CreateClassifier_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (CreateClassifier_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const CreateClassifier_Request_& instance_data) = 0;

            protected:
                CreateClassifier_Request_DataWriter () {};
                ~CreateClassifier_Request_DataWriter () {};
            private:
                CreateClassifier_Request_DataWriter (const CreateClassifier_Request_DataWriter &);
                CreateClassifier_Request_DataWriter & operator = (const CreateClassifier_Request_DataWriter &);
            };

            class  CreateClassifier_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef CreateClassifier_Request_DataReader_ptr _ptr_type;
                typedef CreateClassifier_Request_DataReader_var _var_type;

                static CreateClassifier_Request_DataReader_ptr _duplicate (CreateClassifier_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CreateClassifier_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static CreateClassifier_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CreateClassifier_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                CreateClassifier_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (CreateClassifier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (CreateClassifier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (CreateClassifier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (CreateClassifier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (CreateClassifier_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (CreateClassifier_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (CreateClassifier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (CreateClassifier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (CreateClassifier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (CreateClassifier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (CreateClassifier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (CreateClassifier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (CreateClassifier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (CreateClassifier_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const CreateClassifier_Request_& instance) = 0;

            protected:
                CreateClassifier_Request_DataReader () {};
                ~CreateClassifier_Request_DataReader () {};
            private:
                CreateClassifier_Request_DataReader (const CreateClassifier_Request_DataReader &);
                CreateClassifier_Request_DataReader & operator = (const CreateClassifier_Request_DataReader &);
            };

            class  CreateClassifier_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef CreateClassifier_Request_DataReaderView_ptr _ptr_type;
                typedef CreateClassifier_Request_DataReaderView_var _var_type;

                static CreateClassifier_Request_DataReaderView_ptr _duplicate (CreateClassifier_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CreateClassifier_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static CreateClassifier_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CreateClassifier_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                CreateClassifier_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (CreateClassifier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (CreateClassifier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (CreateClassifier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (CreateClassifier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (CreateClassifier_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (CreateClassifier_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (CreateClassifier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (CreateClassifier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (CreateClassifier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (CreateClassifier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (CreateClassifier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (CreateClassifier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (CreateClassifier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (CreateClassifier_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const CreateClassifier_Request_& instance) = 0;

            protected:
                CreateClassifier_Request_DataReaderView () {};
                ~CreateClassifier_Request_DataReaderView () {};
            private:
                CreateClassifier_Request_DataReaderView (const CreateClassifier_Request_DataReaderView &);
                CreateClassifier_Request_DataReaderView & operator = (const CreateClassifier_Request_DataReaderView &);
            };
        }

    }

}

#endif
