#ifndef _H_350BBC612D7EDA38F755340A28CEEEE8_CreateClassifier_Response_DCPS_H_
#define _H_350BBC612D7EDA38F755340A28CEEEE8_CreateClassifier_Response_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "CreateClassifier_Response_.h"


namespace ml_classifiers
{
    namespace srv
    {
        namespace dds_
        {
            class CreateClassifier_Response_TypeSupportInterface;

            typedef CreateClassifier_Response_TypeSupportInterface * CreateClassifier_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < CreateClassifier_Response_TypeSupportInterface> CreateClassifier_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < CreateClassifier_Response_TypeSupportInterface> CreateClassifier_Response_TypeSupportInterface_out;


            class CreateClassifier_Response_DataWriter;

            typedef CreateClassifier_Response_DataWriter * CreateClassifier_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < CreateClassifier_Response_DataWriter> CreateClassifier_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < CreateClassifier_Response_DataWriter> CreateClassifier_Response_DataWriter_out;


            class CreateClassifier_Response_DataReader;

            typedef CreateClassifier_Response_DataReader * CreateClassifier_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < CreateClassifier_Response_DataReader> CreateClassifier_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < CreateClassifier_Response_DataReader> CreateClassifier_Response_DataReader_out;


            class CreateClassifier_Response_DataReaderView;

            typedef CreateClassifier_Response_DataReaderView * CreateClassifier_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < CreateClassifier_Response_DataReaderView> CreateClassifier_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < CreateClassifier_Response_DataReaderView> CreateClassifier_Response_DataReaderView_out;

            struct CreateClassifier_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < CreateClassifier_Response_, struct CreateClassifier_Response_Seq_uniq_> CreateClassifier_Response_Seq;
            typedef DDS_DCPSSequence_var < CreateClassifier_Response_Seq> CreateClassifier_Response_Seq_var;
            typedef DDS_DCPSSequence_out < CreateClassifier_Response_Seq> CreateClassifier_Response_Seq_out;

            class  CreateClassifier_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef CreateClassifier_Response_TypeSupportInterface_ptr _ptr_type;
                typedef CreateClassifier_Response_TypeSupportInterface_var _var_type;

                static CreateClassifier_Response_TypeSupportInterface_ptr _duplicate (CreateClassifier_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CreateClassifier_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static CreateClassifier_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CreateClassifier_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                CreateClassifier_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                CreateClassifier_Response_TypeSupportInterface () {};
                ~CreateClassifier_Response_TypeSupportInterface () {};
            private:
                CreateClassifier_Response_TypeSupportInterface (const CreateClassifier_Response_TypeSupportInterface &);
                CreateClassifier_Response_TypeSupportInterface & operator = (const CreateClassifier_Response_TypeSupportInterface &);
            };

            class  CreateClassifier_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef CreateClassifier_Response_DataWriter_ptr _ptr_type;
                typedef CreateClassifier_Response_DataWriter_var _var_type;

                static CreateClassifier_Response_DataWriter_ptr _duplicate (CreateClassifier_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CreateClassifier_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static CreateClassifier_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CreateClassifier_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                CreateClassifier_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const CreateClassifier_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const CreateClassifier_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const CreateClassifier_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const CreateClassifier_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const CreateClassifier_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const CreateClassifier_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const CreateClassifier_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const CreateClassifier_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const CreateClassifier_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const CreateClassifier_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (CreateClassifier_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const CreateClassifier_Response_& instance_data) = 0;

            protected:
                CreateClassifier_Response_DataWriter () {};
                ~CreateClassifier_Response_DataWriter () {};
            private:
                CreateClassifier_Response_DataWriter (const CreateClassifier_Response_DataWriter &);
                CreateClassifier_Response_DataWriter & operator = (const CreateClassifier_Response_DataWriter &);
            };

            class  CreateClassifier_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef CreateClassifier_Response_DataReader_ptr _ptr_type;
                typedef CreateClassifier_Response_DataReader_var _var_type;

                static CreateClassifier_Response_DataReader_ptr _duplicate (CreateClassifier_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CreateClassifier_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static CreateClassifier_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CreateClassifier_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                CreateClassifier_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (CreateClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (CreateClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (CreateClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (CreateClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (CreateClassifier_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (CreateClassifier_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (CreateClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (CreateClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (CreateClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (CreateClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (CreateClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (CreateClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (CreateClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (CreateClassifier_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const CreateClassifier_Response_& instance) = 0;

            protected:
                CreateClassifier_Response_DataReader () {};
                ~CreateClassifier_Response_DataReader () {};
            private:
                CreateClassifier_Response_DataReader (const CreateClassifier_Response_DataReader &);
                CreateClassifier_Response_DataReader & operator = (const CreateClassifier_Response_DataReader &);
            };

            class  CreateClassifier_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef CreateClassifier_Response_DataReaderView_ptr _ptr_type;
                typedef CreateClassifier_Response_DataReaderView_var _var_type;

                static CreateClassifier_Response_DataReaderView_ptr _duplicate (CreateClassifier_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CreateClassifier_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static CreateClassifier_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CreateClassifier_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                CreateClassifier_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (CreateClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (CreateClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (CreateClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (CreateClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (CreateClassifier_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (CreateClassifier_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (CreateClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (CreateClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (CreateClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (CreateClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (CreateClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (CreateClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (CreateClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (CreateClassifier_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const CreateClassifier_Response_& instance) = 0;

            protected:
                CreateClassifier_Response_DataReaderView () {};
                ~CreateClassifier_Response_DataReaderView () {};
            private:
                CreateClassifier_Response_DataReaderView (const CreateClassifier_Response_DataReaderView &);
                CreateClassifier_Response_DataReaderView & operator = (const CreateClassifier_Response_DataReaderView &);
            };
        }

    }

}

#endif
