#ifndef _H_A486C4E08573B2669E8A19137E32DCC2_LoadClassifier_Response_DCPS_H_
#define _H_A486C4E08573B2669E8A19137E32DCC2_LoadClassifier_Response_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "LoadClassifier_Response_.h"


namespace ml_classifiers
{
    namespace srv
    {
        namespace dds_
        {
            class LoadClassifier_Response_TypeSupportInterface;

            typedef LoadClassifier_Response_TypeSupportInterface * LoadClassifier_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < LoadClassifier_Response_TypeSupportInterface> LoadClassifier_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < LoadClassifier_Response_TypeSupportInterface> LoadClassifier_Response_TypeSupportInterface_out;


            class LoadClassifier_Response_DataWriter;

            typedef LoadClassifier_Response_DataWriter * LoadClassifier_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < LoadClassifier_Response_DataWriter> LoadClassifier_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < LoadClassifier_Response_DataWriter> LoadClassifier_Response_DataWriter_out;


            class LoadClassifier_Response_DataReader;

            typedef LoadClassifier_Response_DataReader * LoadClassifier_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < LoadClassifier_Response_DataReader> LoadClassifier_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < LoadClassifier_Response_DataReader> LoadClassifier_Response_DataReader_out;


            class LoadClassifier_Response_DataReaderView;

            typedef LoadClassifier_Response_DataReaderView * LoadClassifier_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < LoadClassifier_Response_DataReaderView> LoadClassifier_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < LoadClassifier_Response_DataReaderView> LoadClassifier_Response_DataReaderView_out;

            struct LoadClassifier_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < LoadClassifier_Response_, struct LoadClassifier_Response_Seq_uniq_> LoadClassifier_Response_Seq;
            typedef DDS_DCPSSequence_var < LoadClassifier_Response_Seq> LoadClassifier_Response_Seq_var;
            typedef DDS_DCPSSequence_out < LoadClassifier_Response_Seq> LoadClassifier_Response_Seq_out;

            class  LoadClassifier_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef LoadClassifier_Response_TypeSupportInterface_ptr _ptr_type;
                typedef LoadClassifier_Response_TypeSupportInterface_var _var_type;

                static LoadClassifier_Response_TypeSupportInterface_ptr _duplicate (LoadClassifier_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LoadClassifier_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static LoadClassifier_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LoadClassifier_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                LoadClassifier_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                LoadClassifier_Response_TypeSupportInterface () {};
                ~LoadClassifier_Response_TypeSupportInterface () {};
            private:
                LoadClassifier_Response_TypeSupportInterface (const LoadClassifier_Response_TypeSupportInterface &);
                LoadClassifier_Response_TypeSupportInterface & operator = (const LoadClassifier_Response_TypeSupportInterface &);
            };

            class  LoadClassifier_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef LoadClassifier_Response_DataWriter_ptr _ptr_type;
                typedef LoadClassifier_Response_DataWriter_var _var_type;

                static LoadClassifier_Response_DataWriter_ptr _duplicate (LoadClassifier_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LoadClassifier_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static LoadClassifier_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LoadClassifier_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                LoadClassifier_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const LoadClassifier_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const LoadClassifier_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const LoadClassifier_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const LoadClassifier_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const LoadClassifier_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const LoadClassifier_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const LoadClassifier_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const LoadClassifier_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const LoadClassifier_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const LoadClassifier_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (LoadClassifier_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const LoadClassifier_Response_& instance_data) = 0;

            protected:
                LoadClassifier_Response_DataWriter () {};
                ~LoadClassifier_Response_DataWriter () {};
            private:
                LoadClassifier_Response_DataWriter (const LoadClassifier_Response_DataWriter &);
                LoadClassifier_Response_DataWriter & operator = (const LoadClassifier_Response_DataWriter &);
            };

            class  LoadClassifier_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef LoadClassifier_Response_DataReader_ptr _ptr_type;
                typedef LoadClassifier_Response_DataReader_var _var_type;

                static LoadClassifier_Response_DataReader_ptr _duplicate (LoadClassifier_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LoadClassifier_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static LoadClassifier_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LoadClassifier_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                LoadClassifier_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (LoadClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (LoadClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (LoadClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (LoadClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (LoadClassifier_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (LoadClassifier_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (LoadClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (LoadClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (LoadClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (LoadClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (LoadClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (LoadClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (LoadClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (LoadClassifier_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const LoadClassifier_Response_& instance) = 0;

            protected:
                LoadClassifier_Response_DataReader () {};
                ~LoadClassifier_Response_DataReader () {};
            private:
                LoadClassifier_Response_DataReader (const LoadClassifier_Response_DataReader &);
                LoadClassifier_Response_DataReader & operator = (const LoadClassifier_Response_DataReader &);
            };

            class  LoadClassifier_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef LoadClassifier_Response_DataReaderView_ptr _ptr_type;
                typedef LoadClassifier_Response_DataReaderView_var _var_type;

                static LoadClassifier_Response_DataReaderView_ptr _duplicate (LoadClassifier_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LoadClassifier_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static LoadClassifier_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LoadClassifier_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                LoadClassifier_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (LoadClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (LoadClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (LoadClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (LoadClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (LoadClassifier_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (LoadClassifier_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (LoadClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (LoadClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (LoadClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (LoadClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (LoadClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (LoadClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (LoadClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (LoadClassifier_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const LoadClassifier_Response_& instance) = 0;

            protected:
                LoadClassifier_Response_DataReaderView () {};
                ~LoadClassifier_Response_DataReaderView () {};
            private:
                LoadClassifier_Response_DataReaderView (const LoadClassifier_Response_DataReaderView &);
                LoadClassifier_Response_DataReaderView & operator = (const LoadClassifier_Response_DataReaderView &);
            };
        }

    }

}

#endif
