#ifndef _H_39FFC48CCC5752092205A3AB0AE5F094_SaveClassifier_Response_DCPS_H_
#define _H_39FFC48CCC5752092205A3AB0AE5F094_SaveClassifier_Response_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "SaveClassifier_Response_.h"


namespace ml_classifiers
{
    namespace srv
    {
        namespace dds_
        {
            class SaveClassifier_Response_TypeSupportInterface;

            typedef SaveClassifier_Response_TypeSupportInterface * SaveClassifier_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SaveClassifier_Response_TypeSupportInterface> SaveClassifier_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SaveClassifier_Response_TypeSupportInterface> SaveClassifier_Response_TypeSupportInterface_out;


            class SaveClassifier_Response_DataWriter;

            typedef SaveClassifier_Response_DataWriter * SaveClassifier_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SaveClassifier_Response_DataWriter> SaveClassifier_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < SaveClassifier_Response_DataWriter> SaveClassifier_Response_DataWriter_out;


            class SaveClassifier_Response_DataReader;

            typedef SaveClassifier_Response_DataReader * SaveClassifier_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SaveClassifier_Response_DataReader> SaveClassifier_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < SaveClassifier_Response_DataReader> SaveClassifier_Response_DataReader_out;


            class SaveClassifier_Response_DataReaderView;

            typedef SaveClassifier_Response_DataReaderView * SaveClassifier_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SaveClassifier_Response_DataReaderView> SaveClassifier_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SaveClassifier_Response_DataReaderView> SaveClassifier_Response_DataReaderView_out;

            struct SaveClassifier_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < SaveClassifier_Response_, struct SaveClassifier_Response_Seq_uniq_> SaveClassifier_Response_Seq;
            typedef DDS_DCPSSequence_var < SaveClassifier_Response_Seq> SaveClassifier_Response_Seq_var;
            typedef DDS_DCPSSequence_out < SaveClassifier_Response_Seq> SaveClassifier_Response_Seq_out;

            class  SaveClassifier_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SaveClassifier_Response_TypeSupportInterface_ptr _ptr_type;
                typedef SaveClassifier_Response_TypeSupportInterface_var _var_type;

                static SaveClassifier_Response_TypeSupportInterface_ptr _duplicate (SaveClassifier_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SaveClassifier_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SaveClassifier_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SaveClassifier_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SaveClassifier_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SaveClassifier_Response_TypeSupportInterface () {};
                ~SaveClassifier_Response_TypeSupportInterface () {};
            private:
                SaveClassifier_Response_TypeSupportInterface (const SaveClassifier_Response_TypeSupportInterface &);
                SaveClassifier_Response_TypeSupportInterface & operator = (const SaveClassifier_Response_TypeSupportInterface &);
            };

            class  SaveClassifier_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SaveClassifier_Response_DataWriter_ptr _ptr_type;
                typedef SaveClassifier_Response_DataWriter_var _var_type;

                static SaveClassifier_Response_DataWriter_ptr _duplicate (SaveClassifier_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SaveClassifier_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SaveClassifier_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SaveClassifier_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SaveClassifier_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SaveClassifier_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SaveClassifier_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SaveClassifier_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SaveClassifier_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SaveClassifier_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SaveClassifier_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SaveClassifier_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SaveClassifier_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SaveClassifier_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SaveClassifier_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SaveClassifier_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SaveClassifier_Response_& instance_data) = 0;

            protected:
                SaveClassifier_Response_DataWriter () {};
                ~SaveClassifier_Response_DataWriter () {};
            private:
                SaveClassifier_Response_DataWriter (const SaveClassifier_Response_DataWriter &);
                SaveClassifier_Response_DataWriter & operator = (const SaveClassifier_Response_DataWriter &);
            };

            class  SaveClassifier_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SaveClassifier_Response_DataReader_ptr _ptr_type;
                typedef SaveClassifier_Response_DataReader_var _var_type;

                static SaveClassifier_Response_DataReader_ptr _duplicate (SaveClassifier_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SaveClassifier_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SaveClassifier_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SaveClassifier_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SaveClassifier_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SaveClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SaveClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SaveClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SaveClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SaveClassifier_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SaveClassifier_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SaveClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SaveClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SaveClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SaveClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SaveClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SaveClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SaveClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SaveClassifier_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SaveClassifier_Response_& instance) = 0;

            protected:
                SaveClassifier_Response_DataReader () {};
                ~SaveClassifier_Response_DataReader () {};
            private:
                SaveClassifier_Response_DataReader (const SaveClassifier_Response_DataReader &);
                SaveClassifier_Response_DataReader & operator = (const SaveClassifier_Response_DataReader &);
            };

            class  SaveClassifier_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SaveClassifier_Response_DataReaderView_ptr _ptr_type;
                typedef SaveClassifier_Response_DataReaderView_var _var_type;

                static SaveClassifier_Response_DataReaderView_ptr _duplicate (SaveClassifier_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SaveClassifier_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SaveClassifier_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SaveClassifier_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SaveClassifier_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SaveClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SaveClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SaveClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SaveClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SaveClassifier_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SaveClassifier_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SaveClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SaveClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SaveClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SaveClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SaveClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SaveClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SaveClassifier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SaveClassifier_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SaveClassifier_Response_& instance) = 0;

            protected:
                SaveClassifier_Response_DataReaderView () {};
                ~SaveClassifier_Response_DataReaderView () {};
            private:
                SaveClassifier_Response_DataReaderView (const SaveClassifier_Response_DataReaderView &);
                SaveClassifier_Response_DataReaderView & operator = (const SaveClassifier_Response_DataReaderView &);
            };
        }

    }

}

#endif
